/* gui-js/edit_text.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mar. févr. 14 09:57:00 CET 2012
version mar. févr. 14 14:08:14 CET 2012

Edit the innerHTML of a DOM element that registered to this service.
 then put the typed string in the .source of the element
*/

alpha_array="_0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
alpha_chars=[];
for (var i in alpha_array)
  alpha_chars[alpha_array[i]]=1;

edit_text={
  div:null,
  old_mousehandler:null,
  current_elem: null,
  current_text: null,
  filteralpha:new RegExp("[^"+alpha_array+"]","ig"),

  filter_alpha: function(t){
    if (t.value)  // TODO : recode
      t.value=t.value.replace(edit_text.filteralpha,"");
    else
      t.value=edit_text.current_elem.edit.defaultValue;
  },

  filter_number: function(t){
    if (t.value)  // TODO : recode
      t.value=t.value.replace(/[^_0123456789hHbB]/ig,"");
    else
      t.value="0";
  },

  register: function(elem, o) {
    if (typeof elem=="object"){
/* format :
    {
      size:,
      maxsize:,
      check:,
      func:  // callback function
    }
*/
      if (typeof o!="object")
        o={};
      if (typeof o.size!="number")
        o.size=30;
      if (typeof o.defaultValue!="string")
        o.defaultValue="_empty_";
      if (typeof o.maxsize !="number")
        o.maxsize=500;

      elem.edit=o;
      elem.style.cursor="pointer";
      elem.onclick=edit_text.start;
    }
  },

  check:function(e){
    switch('which' in e ? e.which : e.keyCode){
      case 13: edit_text.stop(true);  break; // Enter
      case 27: edit_text.stop(false); break; // Esc
      default:  // check
        var c=edit_text.current_elem.edit;
        if(typeof c.check=="function"){
          if(this.vallen!=this.value.length)
            c.check(this);
          this.vallen=this.value.length;
        }
    }
  },

  start: function(e) {
    if(edit_text.current_elem!=this){
      if(edit_text.current_elem)
        edit_text.stop(true);
      if (!edit_text.div)
        edit_text.init(); // ensure the DIV exists
      e = e || window.event;
      var d=edit_text.div, // the div
          t=d.firstChild,  // the text
          b=document.body || document.documentElement;

      d.style.display="block"; // make the div visible near the mouse pointer
      d.style.left=((e.pageX || e.clientX + b.scrollLeft)+10)+"px";
      d.style.top =((e.pageY || e.clientY + b.scrollTop )+10)+"px";
      o=this.edit;
      t.size=o.size; // resize the text input
      t.maxlength=o.maxsize;
      if(typeof this.source!="string")
        this.source=this.innerHTML.replace(/&nbsp;/g," ").replace(/&lt;/g,"<").replace(/&amp;/g,"&");
      t.value=this.source;
      edit_text.current_elem=this;
      t.focus();
      t.onkeyup=edit_text.check;
      edit_text.old_mousehandler=document.onmousedown;
      document.onmousedown=function(e){
        if(!e) e = window.event;
        var t= e.target != null ? e.target : e.srcElement;
        if (t.id!="edit_source")
          edit_text.stop(true);
      }
    }
    return false;
  },

  stop: function(save) {
    // restore the old handler
    document.onmousedown=edit_text.old_mousehandler;

    var d=edit_text.div,
        l=edit_text.current_elem,
        v=d.firstChild.value;
    d.style.display="none"; // hide the div

    if(save) {
      // A last check, just in case
      if(typeof l.edit.check=="function")
        l.edit.check(this);

       // update the element
      l.source=v;
      if(v)
        v=v.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
      l.innerHTML=v;

      // finally call eventual user functions
      if (typeof l.edit.func == "function")
        l.edit.func(l);
    }
    edit_text.current_elem=null;
  },

  init: function(){
    var d=dcE("DIV"),
        t=dcE("input"),
        s=d.style;
    s.position="absolute";
    s.background="none";

    t.type="text";
    t.id="edit_source";
    d.appendChild(t);
    document.body.appendChild(d);
    if (typeof ygwm=="object")
      d.style.zIndex=ygwm.noScrollIndex;
    edit_text.div=d;
  }
};
